######################################################################
######################################################################

proc read_vrml {file cell prefix} {
    
  set f [open $file r];
  set done 0; 

  set scan [vrml_scan $f];
  close $f;         
                    
  if {$scan == {}} {
    return;
  }

  catch {cell create $cell};
  if [catch {set output [vrml_parse $cell $prefix]}] {
    return;
  }                 
                    
  while {[llength $output] == 2} {  
    catch {close $t};
    set skip 1;
    if ![string compare [lindex $output 0] "Texture2"] {
      if [catch {set t [open [lindex $output 1] r]}] {
        set opened 0;
      } else { 
        set opened 1;
      }
      if $opened {
        if [catch {set output [vrml_continue $t]}] {
          catch {close $t};
          set skip 1;
        } else {
          set skip 0;
        }
      } else {
        set skip 1;
      }
    }
    if $skip {
      if [catch {set output [vrml_skip]}] {
        return;
      }
    }
  } 
  catch {close $t};
  return $output;
}
